package jesse.keeblarcraft.GuiMgr;

import jesse.keeblarcraft.Utils.CustomSlot;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.screen.ScreenHandler;
import net.minecraft.screen.slot.Slot;
import net.minecraft.text.Text;
import net.minecraft.village.Merchant;
import net.minecraft.village.MerchantInventory;
import net.minecraft.village.SimpleMerchant;
import net.minecraft.village.TradeOfferList;

import java.util.HashMap;
import java.util.Map;

public class ShopKeeperHandler extends ScreenHandler {
    private Merchant merchant;
    private MerchantInventory merchantInventory;
    boolean canRefreshTrades = false;
    boolean isLeveledMerchant = false;
    int levelAmount = 0;
    int merchantExperience = 0;
    Map<Text, Integer> slotIdByName = new HashMap<>();

    public ShopKeeperHandler(int syncId, PlayerInventory playerInventory) {
        this(syncId, playerInventory, new SimpleMerchant(playerInventory.player));
    }

    public ShopKeeperHandler(int syncId, PlayerInventory playerInventory, Merchant merchant) {
        super(ScreenHandlerRegistration.SHOP_KEEPER_HANDLER_SCREEN_HANDLER_TYPE, syncId);
        this.merchant = merchant;
        this.merchantInventory = new MerchantInventory(merchant);
        // Add slots below
//        this.addSlot(new Slot(this.merchantInventory, 0, 136, 37));
        this.addSlot(new CustomSlot(this.merchantInventory, 0, Text.of("test"), 136, 37), Text.of("test"));
    }

    public void HideSlot(Text slotName) {
        this.getSlot(Text.of("test")).setEnabled(false);
    }

    public void ShowSlot(Text slotName) {
        this.getSlot(Text.of("test")).setEnabled(true);
    }

    protected void addSlot(CustomSlot slot, Text name) {
        super.addSlot(slot);
        slotIdByName.put(name, slot.id);
    }

    public CustomSlot getSlot(Text name) {

        System.out.println("Printing slot map");
        for (Slot slot : super.slots) {
            System.out.println("Found slot with id: " + slot.id);
        }

        System.out.println("Printing self stored map");
        for (Map.Entry<Text, Integer> entry : this.slotIdByName.entrySet()) {
            System.out.println("entry set id value: " + "K: " + entry.getKey() + " -> V: " + entry.getValue());
        }

        return (CustomSlot) super.getSlot(slotIdByName.get(name));
    }

    public void SetOffers(TradeOfferList offers) {
        this.merchant.setOffersFromServer(offers);
    }

    public void SetExperienceLevel(int xp) {
        this.merchantExperience = xp;
    }

    public void SetLevelProgress(int level) {
        this.levelAmount = level;
    }

    public void SetLeveled(boolean leveled) {
        this.isLeveledMerchant = leveled;
    }

    public void SetCanRefreshTrades(boolean isRefreshable) {
        this.canRefreshTrades = isRefreshable;
    }

    @Override
    public ItemStack quickMove(PlayerEntity player, int slot) {
        return null;
    }

    // Called every tick
    @Override
    public boolean canUse(PlayerEntity player) {
        return true;
    }
}
